#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>
#include "fileutil.h"
#include "vmcl2.h"
#include "ran1.h"

extern void Calc_P();
extern void Est_capture_probs();
extern void Ecp_random_model();
extern void Get_p1r();
extern void Get_h();
extern float Get_lh();

float  ranges[50], mut_range, best_err, cur_err;
extern long idnum;
extern float eta, mu, zeta, delta, beta, min_area, B;
extern float orig_eta, orig_mu, orig_zeta, orig_delta, orig_beta, orig_B, orig_fit;
extern int   dayc, init_ps, clfp, fixed_vec[10];
extern char  z_eq_b, use_edge, do_sa, div_or_bin;
extern struct m_day *days;
int mmode;


/********************** Error **************************/
float Get_error_old()
{
  Calc_P();

  Ecp_random_model();

  Get_p1r();

  Get_h();

  return -Get_lh();
}

/********************** Error **************************/
float Get_error()
{
  float err, penalty;

  Calc_P();

  Ecp_random_model();

  Get_p1r();

  Get_h();

  cur_err = err = -Get_lh();

  if (fabs(err-orig_fit)<1.9299)
    penalty=0;
  else
    penalty = 1000.0*(err-orig_fit-1.9299);

  if (mmode)
    {
      switch (clfp)
        {
          case 1: return mu    +penalty;
          case 2: return eta   +penalty;
          case 3: return zeta  +penalty;
          case 4: return beta  +penalty;
          case 5: return delta +penalty;
          case 6: return B     +penalty;
          default: return MAXFLOAT;
        }
    }
  else
    {
      switch (clfp)
        {
          case 1: return -mu    +penalty;
          case 2: return -eta   +penalty;
          case 3: return -zeta  +penalty;
          case 4: return -beta  +penalty;
          case 5: return -delta +penalty;
          case 6: return -B     +penalty;
          default: return MAXFLOAT;
        }
    }
}



/********************** Decode ***************************************/
int Decode(float *str)
{

  if (str[1]<=0)
    str[1]=0.0000001;
  if (str[1]>=1)
    str[1]=0.9999999;
  mu = str[1];

  if (str[3]>0)
    str[3]=0;
  zeta = str[3];

  if (str[2]<0)
    str[2]=0;
  if (str[2]>=(1.0/pow(min_area, zeta)))
    {
      str[2]= 0.9999999/pow(min_area, zeta);
    }
  eta= str[2];

  if (str[4]<0)
    str[4]=0;
  beta = str[4];

  if (str[5]<0)
    str[5]=0;
  delta = str[5];

  if (z_eq_b==Yes)
    B=-zeta;
  else
    {
      if (str[6]<0)
      	str[6]=0;
      B = str[6];
    }
  return True;

}


/********************** Print_func ***********************************/
void Print_func_old(int generation, float estimate, float *str)
{
  Decode(str);
  printf("%i Err:%-7.4f :%-7.3f eta:%-7.3f zeta:%-7.3f :%-7.3f :%-7.3f B:%-7.3f\n",
	 generation, estimate, mu, eta, zeta, beta, delta, B);
}

/********************** Print_func ***********************************/
void Print_func(int generation, float estimate, float *str, float err)
{
  Decode(str);
  Raport("%i Err:%-7.4f Diff:%7.4f :%-7.3f eta:%-7.3f zeta:%-7.3f :%-7.3f :%-7.3f B:%-7.3f\n",
	 generation, estimate, err-orig_fit, mu, eta, zeta, beta, delta, B);
}


/********************** Fitness **************************************/
float Fitness(float *str) {
  if (Decode(str))
    return Get_error();
  else
    return 1000000;
}


/***************** Rand_str ***********************************************/
void Rand_str(float *str)
{
  int   loop;

  str[1]=0.3*ran1(&idnum);
  str[2]=0.7*ran1(&idnum);
  str[3]=-0.7*ran1(&idnum);
  str[4]=8.0*ran1(&idnum);
  str[5]=4.0*ran1(&idnum);
  if (z_eq_b==No)
    str[6]=0.7*ran1(&idnum);
}

/****************** Mutate_old *******************************************/
static void Mutate_old(float *str, float pm, int len)
{
  int loop, mc;

    for(loop=1; loop<=len; loop++)
      {
        if (fixed_vec[loop]==1)
          {
            if (mmode)
              {
                if (ran1(&idnum)<0.75)
      	          str[loop] -= fabs(ranges[loop]*mut_range*gasdev(&idnum));
                else
      	          str[loop] += fabs(ranges[loop]*mut_range*gasdev(&idnum));
              }
            else
              {
                if (ran1(&idnum)<0.75)
      	          str[loop] += fabs(ranges[loop]*mut_range*gasdev(&idnum));
                else
      	          str[loop] -= fabs(ranges[loop]*mut_range*gasdev(&idnum));
              }
//      	      str[loop] += ranges[loop]*mut_range*gasdev(&idnum);
            break;
          }
      }

  do {
    mc=0;
    for(loop=1; loop<=len; loop++)
      {
        if (fixed_vec[loop]==1)
          continue;
        if (ran1(&idnum)<pm)
          {
      	    str[loop] += ranges[loop]*mut_range*gasdev(&idnum);
            mc++;
          }
      }
  } while ((mc==0) && (ran1(&idnum)<0.9));
}

void popcpy(float *dest, float *src, int len)
{
  memcpy((void *)dest, (void *)src, len*sizeof(float));
}

/************************* Get_start ***********************************/
void Get_start(float *pop, float *bf, float *bp, int str_len, int pop_size)
{
  int   loop;
  float seed[50], fit;

  pop[1]=orig_mu;
  pop[2]=orig_eta;
  pop[3]=orig_zeta;
  pop[4]=orig_beta;
  pop[5]=orig_delta;
  pop[6]=orig_B;

#if 0
  if (clfp==1)
    pop[1] = mu;
  else if (clfp==2)
    pop[2] = eta;
  else if (clfp==3)
    pop[3] = zeta;
  else if (clfp==4)
    pop[4] = beta;
  else if (clfp==5)
    pop[5] = delta;
  else
    pop[6] = B;
#endif

  if (z_eq_b==Yes)
    {
      pop[3]=zeta;
      pop[6]=-zeta;

    }

  fit = Fitness(pop);
	*bf = fit;
  popcpy(&bp[1], &pop[1], str_len);

  printf("Starting point, fitn.: %0.0f %0.0f\n", *bf, Fitness(pop));
}

/********************** sa *********************************************/
void sa(float *cp, float *bp, float *bf, float temptr, int iter, int len)
{
  int   loop;
  float fit, cf, ocp[50];

  cf = Fitness(cp);
  printf("%0.3f ", cf);
  popcpy(&ocp[1], &cp[1], len);

  for (loop=0; loop<iter; loop++)
    {
      Mutate_old(cp, 1.0/len, len);
      fit = Fitness(cp);
      if (fit==10000)
	      {
		      popcpy(&cp[1], &ocp[1], len);
		      continue;
      	}

      if (fit<cf)
	      {
		      cf = fit;
		      if (fit< *bf)
		        {
              best_err = cur_err;
		          *bf=fit;
		          popcpy(&bp[1], &cp[1], len);
		        }
		      popcpy(&ocp[1], &cp[1], len);
	       }
      else if (ran1(&idnum) < exp(-(fit-cf)/temptr))
	      {
		      cf = fit;
		      popcpy(&ocp[1], &cp[1], len);
	      }
      else
      	popcpy(&cp[1], &ocp[1], len);
    }
}


/****************** Estimate ****************************************/
float Estimate(int gens, float min_req_err)
{
  int   loop, new_sin, c, PS, iter, jiter, iiter=10,j, L;
  long  nit;
  char  solution_str[150];
  float point, pm, pc, temptr, ftol, pbf, bf, best_f,
        T0,K,cp[50], bp[50], pbl;

  Raport("PARAMETER ESTIMATION USING SA, %ld EVALUATIONS\n",(long)gens*10L);

  if (z_eq_b==Yes)
    L=5;
  else
    {
      L=6;
      ranges[6]=0.15;
    }

  ranges[1]=0.25*orig_mu+0.01;
  ranges[2]=0.25*orig_eta+0.01;
  ranges[3]=0.25*fabs(orig_zeta)+0.05;
  ranges[4]=0.25*orig_beta+0.5;
  ranges[5]=0.25*orig_delta+0.1;

  bf = 100000000;
  Get_start(cp, &bf, bp, L, init_ps);
  pbf = bf;

  pbl = temptr = T0 = 1.0;
  K   = 10.0*gens;
  printf("\nStarting SA %0.4f \n", pbf);
  nit = 0;
  for (jiter=1;jiter<=gens;jiter++)
    {
      mut_range = exp(-jiter/(0.4*gens));
      printf("n");
      iter=iiter;
      temptr = T0*pow(1.0-nit/K, 2.0);
      sa(cp, bp, &bf, temptr, iter, L);
      if (bf < pbf)
	      {
		      pbf=bf;
          best_err = cur_err;
		      printf("\nBest:%i %0.6f %0.4f err:%0.4f",jiter, temptr, bf, best_err);
		      pbl = temptr;
		      Print_func(jiter, bf, bp, best_err);
	      }
//      temptr *= 0.9;
      if ((temptr/pbl) < 0.75)
	     {
	       popcpy(&cp[1], &bp[1], L);
	     }
      nit += iiter;
      if (bf<min_req_err)
        break;
    }

  best_f = Fitness(bp);
  printf("\nBest found %f \n", best_f);
  Print_func(jiter, best_f, bp, best_err);

  Raport("Final values : \n");
  Raport("Err:%-7.4f :%-7.3f eta:%-7.3f zeta:%-7.3f :%-7.3f :%-7.3f B:%-7.3f \n",
         best_f, mu, eta, zeta, beta, delta, B);

  return best_f;
}
extern float Estimate2(long f_evals, float prev, float *err,
                       float max_err, float l_or_u)
{
  int   loop, new_sin, c, PS, iter, jiter, iiter=100,j, L, gens;
  long  nit;
  char  solution_str[150];
  float point, pm, pc, temptr, ftol, pbf, bf, best_f,
        T0,K,cp[50], bp[50], pbl;

  gens = f_evals/100;
  mmode = l_or_u;
  Raport("PARAMETER ESTIMATION USING SA, %ld EVALUATIONS\n",f_evals);

  ranges[1]=0.2*orig_mu+0.01;
  ranges[2]=0.2*orig_eta+0.01;
  ranges[3]=0.2*fabs(orig_zeta)+0.05;
  ranges[4]=0.2*orig_beta+0.5;
  ranges[5]=0.2*orig_delta+0.1;

  if (z_eq_b==Yes)
    L=5;
  else
    {
      L=6;
      ranges[6]=0.2*fabs(orig_B)+0.05;
    }


  bf = 100000000;
  Get_start(cp, &bf, bp, L, init_ps);
  pbf = bf;

  pbl = temptr = T0 = 1.0;
  K   = 100.0*gens;
  printf("\nStarting SA %0.4f \n", pbf);
  nit = 0;
  for (jiter=1;jiter<=gens;jiter++)
    {
      mut_range = exp(-jiter/(0.4*gens));
      printf("n");
      iter=iiter;
      temptr = T0*pow(1.0-nit/K, 2.0);
      sa(cp, bp, &bf, temptr, iter, L);
      if (bf < pbf)
	      {
		      pbf=bf;
		      printf("\nBest:%i %0.6f %0.4f ",jiter, temptr, bf);
		      pbl = temptr;
		      Print_func(jiter, bf, bp, best_err);
	      }
//      temptr *= 0.9;
      if ((temptr/pbl) < 0.75)
	     {
	       popcpy(&cp[1], &bp[1], L);
	     }
      nit += iiter;
    }

  best_f = Fitness(bp);
  printf("\nBest found %f \n", best_f);
  Print_func(jiter, best_f, bp, best_err);
  *err = best_f;

  Raport("Final values : \n");
  Raport("Err:%-7.4f :%-7.3f eta:%-7.3f zeta:%-7.3f :%-7.3f :%-7.3f B:%-7.3f \n",
         best_f, mu, eta, zeta, beta, delta, B);

  switch (clfp)
    {
      case 1: return mu;
      case 2: return eta;
      case 3: return zeta;
      case 4: return beta;
      case 5: return delta;
      case 6: return B;
      default: return -MINFLOAT;
    }
}
